<?php
namespace Geral\Repositories;

class Itempedido extends \Doctrine\ORM\EntityRepository
{
	public function getPrecoPromo($cdcliente, $cdarvprod, $cdprecobase){
		try{
			$sql =" SELECT DECODE(IDSTATUSPROMO,'AT',VRTOTALPROMO,VRITEPREBASE) AS VRITEPREBASE,
					CDARVPROD,CDPRECOBASE,DTINIVALIPB,DTFIMVALIPB,
					DECODE(IDSTATUSPROMO,'AT','S','N') AS IDPRECOPROM
					FROM
					(
					SELECT
					   1 AS ORDEM,T.VRPRECOPROD AS VRITEPREBASE, P.CDARVPROD,
					   '' AS CDPRECOBASE,NULL AS DTINIVALIPB,NULL AS DTFIMVALIPB,
					   '' AS IDTIPOPROMO,NULL AS DTINIPROMO,NULL AS DTFINPROMO,
					   '' IDDIASPROMO, 0 AS VRTOTALPROMO,'' AS IDSTATUSPROMO
					FROM
					   TABPRECLIE T,PRODUTO P
					WHERE
					   (P.CDARVPROD   = :P_CDARVPROD ) AND
					   (P.CDPRODUTO   = T.CDPRODUTO  ) AND
					   (T.CDCLIENTE   = :P_CDCLIENTE )  AND
					   (
						( (SYSDATE BETWEEN NVL(T.DTVALINI,SYSDATE) AND NVL(T.DTVALFIN,SYSDATE))OR
						  ((SYSDATE >= NVL(T.DTVALINI,SYSDATE))AND(T.DTVALFIN IS NULL))
						)
					   )
					UNION
					SELECT
					   2 AS ORDEM,I.VRITEPREBASE, P.CDARVPROD,
					   I.CDPRECOBASE, I.DTINIVALIPB, I.DTFIMVALIPB,
					   PP.IDTIPOPROMO,PP.DTINIPROMO,PP.DTFINPROMO,
					   PP.IDDIASPROMO,PP.VRTOTALPROMO,PP.IDSTATUSPROMO
					FROM ITEMPREBASE I, PRODUTO P,PROMOPRBASE PP
					WHERE (I.CDPRECOBASE     = :P_CDPRECOBASE)
					  AND (P.CDARVPROD       = :P_CDARVPROD  )
					  AND (I.CDPRODUTO       = P.CDPRODUTO   )
					  AND (PP.CDPRECOBASE    = I.CDPRECOBASE )
					  AND (PP.CDPRODUTO      = I.CDPRODUTO   )
					  AND (PP.DTINIVALIPB    = I.DTINIVALIPB )
					  AND (TO_CHAR(SYSDATE,'DD/MM/YYYY') BETWEEN PP.DTINIPROMO AND PP.DTFINPROMO)
					  AND ((PP.IDDIASPROMO =(TO_CHAR(SYSDATE,'D')))OR(PP.IDDIASPROMO ='8'))
					UNION
					SELECT
					   3 AS ORDEM,I.VRITEPREBASE, P.CDARVPROD,
					   I.CDPRECOBASE, I.DTINIVALIPB, I.DTFIMVALIPB,
					   '' AS IDTIPOPROMO,NULL AS DTINIPROMO,NULL AS DTFINPROMO,
					   '' IDDIASPROMO, 0 AS VRTOTALPROMO,'' AS IDSTATUSPROMO
					FROM ITEMPREBASE I, PRODUTO P
					WHERE (I.CDPRECOBASE     = :P_CDPRECOBASE)
					  AND (P.CDARVPROD       = :P_CDARVPROD  )
					  AND (I.CDPRODUTO       = P.CDPRODUTO   )
					ORDER BY ORDEM
					)
					WHERE ROWNUM = 1 ";
			$params = array(
				'P_CDCLIENTE'   => $cdcliente,
				'P_CDARVPROD'   => $cdarvprod,
				'P_CDPRECOBASE' => $cdprecobase
			);
			
			return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
			
		}catch(\Exception $e){   
			throw $e;
		}
	}

    public function getItempedido($cdfilial, $nrpedido){
        $sql = <<<SQL
          SELECT IT.*, P.CDPRODESTO, P.CDARVPROD, P.NMPRODUTO, IT.QTITEMPED - IT.QTEXPITEMPED AS QTDEAEXP, P.VRFATOCONV
            FROM ITEMPEDIDO IT, PRODUTO P
           WHERE CDFILIAL = :P_CDFILIAL
             AND NRPEDIDO = :P_NRPEDIDO
             AND IT.CDPRODUTO = P.CDPRODUTO
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_NRPEDIDO' => $nrpedido
        );

        return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);

    }

}