CREATE OR REPLACE
PROCEDURE AVL_SETUP (
   P_NRORG IN AVALIACAOGERAL.NRORG%TYPE
) IS
   V_NRCOMBQUESTPADR COMBQUESTPADR.NRCOMBQUESTPADR%TYPE;
   V_NRCOMBQUESTAVAL COMBQUESTAVAL.NRCOMBQUESTAVAL%TYPE;
   V_NRLOCALAVALIACAO AVL_LOCALAVALIACAO.NRLOCALAVALIACAO%TYPE;
   V_NOVOCODIGO VARCHAR2(20);
   V_COUNTPARAMETRO NUMBER;
BEGIN
   SELECT NVL(COUNT(*), 0)
     INTO V_COUNTPARAMETRO
     FROM AVL_PARAMETROGERAL
    WHERE NRORG = P_NRORG;
   -- INSERE OS REGISTROS INICIAIS DO PLANEJAMENTO SOMENTE SE AINDA NO EXISTIR
   -- REGISTRO NA TABELA DE PARMETROS GERAIS DO SISTEMA   
   IF V_COUNTPARAMETRO = 0 THEN  -- ALTERAR DEPOIS PARA "IF V_COUNTPARAMETRO = 0 THEN"
      -- #######################################################################
      -- ########################## AVL_PARAMETROGERAL #########################
      -- #######################################################################
      NOVO_CODIGO('AVL_PARAMETROGERAL', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_PARAMETROGERAL (NRAVLPARAMETROGERAL, DILIMITEPESQMESANTERIOR, NRORG, DTINCLUSAO)
         SELECT V_NOVOCODIGO, 5, P_NRORG, SYSDATE
           FROM DUAL
          WHERE NOT EXISTS 
                (SELECT *
                   FROM AVL_PARAMETROGERAL
                  WHERE NRORG = P_NRORG);
      -- #######################################################################
      -- ############################ TIPOAVALIACAO ############################
      -- #######################################################################
      NOVO_CODIGO('TIPOAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO TIPOAVALIACAO (NRTIPOAVALIACAO, NMTIPOAVALIACAO, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Pesquisa de opinio em restaurante', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM TIPOAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante');
      -- #######################################################################
      -- ########################### AVL_TEMAANALISE ###########################
      -- #######################################################################
      NOVO_CODIGO('AVL_TEMAANALISE', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_TEMAANALISE (NRTEMAANALISE, NMTEMAANALISE, SGTEMAANALISE, NRORG, DTINCLUSAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, 'Atendimento', 'ATE', P_NRORG, SYSDATE, (SELECT NRTIPOAVALIACAO
                                                                      FROM TIPOAVALIACAO
                                                                     WHERE NRORG = P_NRORG
                                                                       AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_TEMAANALISE
               WHERE NRORG = P_NRORG
                 AND NMTEMAANALISE = 'Atendimento'
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      NOVO_CODIGO('AVL_TEMAANALISE', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_TEMAANALISE (NRTEMAANALISE, NMTEMAANALISE, SGTEMAANALISE, NRORG, DTINCLUSAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, 'Cardpio', 'CAR', P_NRORG, SYSDATE, (SELECT NRTIPOAVALIACAO
                                                                   FROM TIPOAVALIACAO
                                                                  WHERE NRORG = P_NRORG
                                                                    AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_TEMAANALISE
               WHERE NRORG = P_NRORG
                 AND NMTEMAANALISE = 'Cardpio'
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      NOVO_CODIGO('AVL_TEMAANALISE', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_TEMAANALISE (NRTEMAANALISE, NMTEMAANALISE, SGTEMAANALISE, NRORG, DTINCLUSAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, 'Limpeza', 'LIM', P_NRORG, SYSDATE, (SELECT NRTIPOAVALIACAO
                                                                  FROM TIPOAVALIACAO
                                                                 WHERE NRORG = P_NRORG
                                                                   AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_TEMAANALISE
               WHERE NRORG = P_NRORG
                 AND NMTEMAANALISE = 'Limpeza'
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      NOVO_CODIGO('AVL_TEMAANALISE', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_TEMAANALISE (NRTEMAANALISE, NMTEMAANALISE, SGTEMAANALISE, NRORG, DTINCLUSAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, 'Organizao', 'ORG', P_NRORG, SYSDATE, (SELECT NRTIPOAVALIACAO
                                                                      FROM TIPOAVALIACAO
                                                                     WHERE NRORG = P_NRORG
                                                                       AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_TEMAANALISE
               WHERE NRORG = P_NRORG
                 AND NMTEMAANALISE = 'Organizao'
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      NOVO_CODIGO('AVL_TEMAANALISE', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO AVL_TEMAANALISE (NRTEMAANALISE, NMTEMAANALISE, SGTEMAANALISE, NRORG, DTINCLUSAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, 'Eventos', 'EVE', P_NRORG, SYSDATE, (SELECT NRTIPOAVALIACAO
                                                                  FROM TIPOAVALIACAO
                                                                 WHERE NRORG = P_NRORG
                                                                   AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_TEMAANALISE
               WHERE NRORG = P_NRORG
                 AND NMTEMAANALISE = 'Eventos'
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      -- #######################################################################
      -- ########################### NIVELAVALIACAO ############################
      -- #######################################################################
      NOVO_CODIGO('NIVELAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELAVALIACAO (NRNIVELAVALIA, NMNIVELAVALIA, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Fcil', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELAVALIA = 'Fcil');
      NOVO_CODIGO('NIVELAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELAVALIACAO (NRNIVELAVALIA, NMNIVELAVALIA, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Mdio', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELAVALIA = 'Mdio');
      NOVO_CODIGO('NIVELAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELAVALIACAO (NRNIVELAVALIA, NMNIVELAVALIA, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Difcil', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELAVALIA = 'Difcil');
      -- #######################################################################
      -- ############################ NIVELQUESTAO #############################
      -- #######################################################################
      NOVO_CODIGO('NIVELQUESTAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELQUESTAO (NRNIVELQUESTAO, NMNIVELQUESTAO, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Fcil', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELQUESTAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELQUESTAO = 'Fcil');
      NOVO_CODIGO('NIVELQUESTAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELQUESTAO (NRNIVELQUESTAO, NMNIVELQUESTAO, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Mdio', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELQUESTAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELQUESTAO = 'Mdio');
      NOVO_CODIGO('NIVELQUESTAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO NIVELQUESTAO (NRNIVELQUESTAO, NMNIVELQUESTAO, NRORG, DTINCLUSAO)
      SELECT V_NOVOCODIGO, 'Difcil', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM NIVELQUESTAO
               WHERE NRORG = P_NRORG
                 AND NMNIVELQUESTAO = 'Difcil');
      -- #######################################################################
      -- ############################### QUESTAO ###############################
      -- #######################################################################
      NOVO_CODIGO('QUESTAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO QUESTAO (NRQUESTAO, TXQUESTAO, IDTIPOQUESTAO, DTREVISAQUESTAO, IDQUESTAOOBRIGA, NRORG, DTINCLUSAO, TXPALAVRACHAVE, NRNIVELPADQUEST)
      SELECT V_NOVOCODIGO, 'COMO EST SUA SATISFAO?', 'FECHADA', NULL, 'S', P_NRORG, SYSDATE, 'SATISFACAO', (SELECT NRNIVELQUESTAO
                                                                                                                 FROM NIVELQUESTAO
                                                                                                                WHERE NRORG = P_NRORG
                                                                                                                  AND NMNIVELQUESTAO = 'Fcil')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM QUESTAO
               WHERE NRORG = P_NRORG
                 AND TXQUESTAO = 'COMO EST SUA SATISFAO?');
      -- #######################################################################
      -- ############################## RESPOSTA ###############################
      -- #######################################################################
      NOVO_CODIGO('RESPOSTA', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO RESPOSTA (NRRESPOSTA, DSRESPOSTA, IDRESPOSCORRETA, VRPESORESPOSTA, NRORDENARESPOST, CDINTEGRACAO, NRORG, DTINCLUSAO, NRQUESTAO)
      SELECT V_NOVOCODIGO, 'MUITO SATISFEITO', 'S', 1, 1, 0, P_NRORG, SYSDATE, (SELECT NRQUESTAO
                                                                                  FROM QUESTAO
                                                                                 WHERE NRORG = P_NRORG
                                                                                   AND TXQUESTAO = 'COMO EST SUA SATISFAO?')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM RESPOSTA
               WHERE NRORG = P_NRORG
                 AND DSRESPOSTA = 'MUITO SATISFEITO'
                 AND NRQUESTAO = (SELECT NRQUESTAO
                                    FROM QUESTAO
                                   WHERE NRORG = P_NRORG
                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?'));
      NOVO_CODIGO('RESPOSTA', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO RESPOSTA (NRRESPOSTA, DSRESPOSTA, IDRESPOSCORRETA, VRPESORESPOSTA, NRORDENARESPOST, CDINTEGRACAO, NRORG, DTINCLUSAO, NRQUESTAO)
      SELECT V_NOVOCODIGO, 'SATISFEITO', 'S', 1, 2, 1, P_NRORG, SYSDATE, (SELECT NRQUESTAO
                                                                            FROM QUESTAO
                                                                           WHERE NRORG = P_NRORG
                                                                             AND TXQUESTAO = 'COMO EST SUA SATISFAO?')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM RESPOSTA
               WHERE NRORG = P_NRORG
                 AND DSRESPOSTA = 'SATISFEITO'
                 AND NRQUESTAO = (SELECT NRQUESTAO
                                    FROM QUESTAO
                                   WHERE NRORG = P_NRORG
                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?'));
      NOVO_CODIGO('RESPOSTA', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO RESPOSTA (NRRESPOSTA, DSRESPOSTA, IDRESPOSCORRETA, VRPESORESPOSTA, NRORDENARESPOST, CDINTEGRACAO, NRORG, DTINCLUSAO, NRQUESTAO)
      SELECT V_NOVOCODIGO, 'INSATISFEITO', 'S', 0, 3, 2, P_NRORG, SYSDATE, (SELECT NRQUESTAO
                                                                              FROM QUESTAO
                                                                             WHERE NRORG = P_NRORG
                                                                               AND TXQUESTAO = 'COMO EST SUA SATISFAO?')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM RESPOSTA
               WHERE NRORG = P_NRORG
                 AND DSRESPOSTA = 'INSATISFEITO'
                 AND NRQUESTAO = (SELECT NRQUESTAO
                                    FROM QUESTAO
                                   WHERE NRORG = P_NRORG
                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?'));
      NOVO_CODIGO('RESPOSTA', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO RESPOSTA (NRRESPOSTA, DSRESPOSTA, IDRESPOSCORRETA, VRPESORESPOSTA, NRORDENARESPOST, CDINTEGRACAO, NRORG, DTINCLUSAO, NRQUESTAO)
      SELECT V_NOVOCODIGO, 'MUITO INSATISFEITO', 'S', 0, 4, 3, P_NRORG, SYSDATE, (SELECT NRQUESTAO
                                                                                    FROM QUESTAO
                                                                                   WHERE NRORG = P_NRORG
                                                                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM RESPOSTA
               WHERE NRORG = P_NRORG
                 AND DSRESPOSTA = 'MUITO INSATISFEITO'
                 AND NRQUESTAO = (SELECT NRQUESTAO
                                    FROM QUESTAO
                                   WHERE NRORG = P_NRORG
                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?'));
      -- #######################################################################
      -- ############################ QUESTIPOAVAL #############################
      -- #######################################################################
      NOVO_CODIGO('QUESTIPOAVAL', V_NOVOCODIGO, 1, P_NRORG);
      INSERT INTO QUESTIPOAVAL (NRQUESTIPOAVAL, NRORG, DTINCLUSAO, NRQUESTAO, NRTIPOAVALIACAO)
      SELECT V_NOVOCODIGO, P_NRORG, SYSDATE, (SELECT NRQUESTAO
                                               FROM QUESTAO
                                              WHERE NRORG = P_NRORG
                                                AND TXQUESTAO = 'COMO EST SUA SATISFAO?'),
                                            (SELECT NRTIPOAVALIACAO
                                               FROM TIPOAVALIACAO
                                              WHERE NRORG = P_NRORG
                                                AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante')
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM QUESTIPOAVAL
               WHERE NRORG = P_NRORG
                 AND NRQUESTAO = (SELECT NRQUESTAO
                                    FROM QUESTAO
                                   WHERE NRORG = P_NRORG
                                     AND TXQUESTAO = 'COMO EST SUA SATISFAO?')
                 AND NRTIPOAVALIACAO = (SELECT NRTIPOAVALIACAO
                                          FROM TIPOAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'));
      -- #######################################################################
      -- ############################ PADRAVALIACAO ############################
      -- #######################################################################
      NOVO_CODIGO('PADRAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO PADRAVALIACAO (
             NRPADRAVALIACAO, NRTIPOAVALIACAO, NRNIVELAVALIA,
             NMPADRAVALIACAO, VRAPROVACAOPADR, QTMINPARTICPADR,
             QTMAXPARTICPADR, NRCRITERIORESUL, IDREGISEXECPADR,
             IDPARTICIPAPADR, IDUTILIZACAOPADR, NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, (SELECT NRTIPOAVALIACAO
                              FROM TIPOAVALIACAO
                             WHERE NRORG = P_NRORG
                               AND NMTIPOAVALIACAO = 'Pesquisa de opinio em restaurante'),
                           (SELECT NRNIVELAVALIA
                              FROM NIVELAVALIACAO
                             WHERE NRORG = P_NRORG
                               AND NMNIVELAVALIA = 'Fcil'),
             'Pesquisa de opinio diria - 4 Respostas', 0, 0,
             0, NULL, 'N',
             'LIVRE', 'PESQUISA_PAINEL', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM PADRAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NRPADRAVALIACAO = (SELECT NRPADRAVALIACAO
                                          FROM PADRAVALIACAO
                                         WHERE NRORG = P_NRORG
                                           AND NMPADRAVALIACAO = 'Pesquisa de opinio diria - 4 Respostas'));
      -- #######################################################################
      -- ############################ COMBQUESTPADR ############################
      -- #######################################################################
      NOVO_CODIGO('COMBQUESTPADR', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO COMBQUESTPADR (
             NRCOMBQUESTPADR, NRPADRAVALIACAO, IDDEFAULT,
             NMCOMBQUESTPADR, NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, (SELECT NRPADRAVALIACAO
                              FROM PADRAVALIACAO
                             WHERE NRORG = P_NRORG
                               AND NMPADRAVALIACAO = 'Pesquisa de opinio diria - 4 Respostas'), 'S',
             'PADRO', P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM COMBQUESTPADR
               WHERE NRORG = P_NRORG
                 AND NRCOMBQUESTPADR = (SELECT NRCOMBQUESTPADR
                                          FROM COMBQUESTPADR
                                         WHERE NRORG = P_NRORG
                                           AND IDDEFAULT = 'S'
                                           AND NRPADRAVALIACAO = (SELECT NRPADRAVALIACAO
                                                                    FROM PADRAVALIACAO
                                                                   WHERE NRORG = P_NRORG
                                                                     AND NMPADRAVALIACAO = 'Pesquisa de opinio diria - 4 Respostas')));
      -- #######################################################################
      -- ############################ QUESTPADRAVAL ############################
      -- #######################################################################
      NOVO_CODIGO('QUESTPADRAVAL', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO QUESTPADRAVAL (
             NRQUESTPADRAVAL, NRCOMBQUESTPADR, NRQUESTAO,
             NRNIVELQUESTAO, NRAGRUPQUESTPAD, VRNOTAQUESTPADR,
             IDSORTQUESTPADR, DSQUESTPADRAVAL, NRORDEQUESTPADR,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, (SELECT NRCOMBQUESTPADR
                              FROM COMBQUESTPADR
                             WHERE NRORG = P_NRORG
                               AND IDDEFAULT = 'S'
                               AND NRPADRAVALIACAO = (SELECT NRPADRAVALIACAO
                                                        FROM PADRAVALIACAO
                                                       WHERE NRORG = P_NRORG
                                                         AND NMPADRAVALIACAO = 'Pesquisa de opinio diria - 4 Respostas')),
                           (SELECT NRQUESTAO
                              FROM QUESTAO
                             WHERE NRORG = P_NRORG
                               AND TXQUESTAO = 'COMO EST SUA SATISFAO?'),
             NULL, NULL, 0,
             'SEM_SORTEIO', 'COMO EST SUA SATISFAO?', 1,
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM QUESTPADRAVAL
               WHERE NRORG = P_NRORG
                 AND NRQUESTPADRAVAL = (SELECT NRQUESTPADRAVAL
                                          FROM QUESTPADRAVAL
                                         WHERE NRORG = P_NRORG
                                           AND NRCOMBQUESTPADR = (SELECT NRCOMBQUESTPADR
                                                                    FROM COMBQUESTPADR
                                                                   WHERE NRORG = P_NRORG
                                                                     AND IDDEFAULT = 'S'
                                                                     AND NRPADRAVALIACAO = (SELECT NRPADRAVALIACAO
                                                                                              FROM PADRAVALIACAO
                                                                                             WHERE NRORG = P_NRORG
                                                                                               AND NMPADRAVALIACAO = 'Pesquisa de opinio diria - 4 Respostas'))
                                           AND NRQUESTAO = (SELECT NRQUESTAO
                                                              FROM QUESTAO
                                                             WHERE NRORG = P_NRORG
                                                               AND TXQUESTAO = 'COMO EST SUA SATISFAO?')));
      -- #######################################################################
      -- ######################### AVL_LOCALAVALIACAO ##########################
      -- #######################################################################
      NOVO_CODIGO('AVL_LOCALAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_LOCALAVALIACAO (
             NRLOCALAVALIACAO, NMLOCALAVALIACAO, SGLOCALAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Restaurante 1', 'R1',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_LOCALAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMLOCALAVALIACAO = 'Restaurante 1');
      NOVO_CODIGO('AVL_LOCALAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_LOCALAVALIACAO (
             NRLOCALAVALIACAO, NMLOCALAVALIACAO, SGLOCALAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Restaurante 2', 'R2',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_LOCALAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMLOCALAVALIACAO = 'Restaurante 2');
      NOVO_CODIGO('AVL_LOCALAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_LOCALAVALIACAO (
             NRLOCALAVALIACAO, NMLOCALAVALIACAO, SGLOCALAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Restaurante 3', 'R3',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_LOCALAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMLOCALAVALIACAO = 'Restaurante 3');
      -- #######################################################################
      -- ########################## AVL_ITEMAVALIACAO ##########################
      -- #######################################################################
      NOVO_CODIGO('AVL_ITEMAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_ITEMAVALIACAO (
             NRITEMAVALIACAO, NMITEMAVALIACAO, SGITEMAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Almoo', 'A',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_ITEMAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMITEMAVALIACAO = 'Almoo');
      NOVO_CODIGO('AVL_ITEMAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_ITEMAVALIACAO (
             NRITEMAVALIACAO, NMITEMAVALIACAO, SGITEMAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Jantar', 'J',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_ITEMAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMITEMAVALIACAO = 'Jantar');
      NOVO_CODIGO('AVL_ITEMAVALIACAO', V_NOVOCODIGO, 1, P_NRORG);
      INSERT 
        INTO AVL_ITEMAVALIACAO (
             NRITEMAVALIACAO, NMITEMAVALIACAO, SGITEMAVALIACAO,
             NRORG, DTINCLUSAO
      )
      SELECT V_NOVOCODIGO, 'Ceia', 'C',
             P_NRORG, SYSDATE
        FROM DUAL
       WHERE NOT EXISTS
             (SELECT *
                FROM AVL_ITEMAVALIACAO
               WHERE NRORG = P_NRORG
                 AND NMITEMAVALIACAO = 'Ceia');
      COMMIT;
   END IF;   
   -- ##########################################################################
   -- ######################## COMBQUESTPADR.IDDEFAULT #########################
   -- ##########################################################################
   FOR P IN (
      SELECT *
        FROM PADRAVALIACAO P
       WHERE P.NRORG = P_NRORG
         AND NOT EXISTS
             (SELECT *
                FROM COMBQUESTPADR C
               WHERE C.NRORG = P.NRORG
                 AND C.IDDEFAULT = 'S'
                 AND C.NRPADRAVALIACAO = P.NRPADRAVALIACAO)
     -- QUESTIONRIOS (PADRAVALIACAO) QUE NO POSSUEM COMBINAO DEFAULT
   ) LOOP
      SELECT NVL(MIN(NRCOMBQUESTPADR), 0)
        INTO V_NRCOMBQUESTPADR
        FROM COMBQUESTPADR C
       WHERE C.NRORG = P.NRORG
         AND C.NRPADRAVALIACAO = P.NRPADRAVALIACAO;
      IF V_NRCOMBQUESTPADR = 0 THEN
         -- SE NO POSSUI NENHUMA COMBINAO CRIA UMA E SETA COMO DEFAULT
         NOVO_CODIGO('COMBQUESTPADR', V_NOVOCODIGO, 1, P_NRORG);
         INSERT
           INTO COMBQUESTPADR (
                NRCOMBQUESTPADR, NRPADRAVALIACAO, NMCOMBQUESTPADR,
                IDDEFAULT, NRORG, DTINCLUSAO
         )
         VALUES (
                V_NRCOMBQUESTPADR, P.NRPADRAVALIACAO, 'PADRO',
                'S', P.NRORG, SYSDATE
         );
      ELSE
         -- SE POSSUI COMBINAO, SETA A PRIMEIRA CRIADA COMO DEFAULT
         UPDATE COMBQUESTPADR
            SET IDDEFAULT = 'S'
          WHERE NRORG = P.NRORG
            AND NRCOMBQUESTPADR = V_NRCOMBQUESTPADR;
      END IF;
   END LOOP;
   -- ##########################################################################
   -- ######################## COMBQUESTAVAL.IDDEFAULT #########################
   -- ##########################################################################
   FOR A IN (
      SELECT *
        FROM AVALIACAOGERAL A
       WHERE A.NRORG = P_NRORG
         AND NOT EXISTS
             (SELECT *
                FROM COMBQUESTAVAL C
               WHERE C.NRORG = A.NRORG
                 AND C.IDDEFAULT = 'S'
                 AND C.NRAVALIACAO = A.NRAVALIACAO)
     -- AVALIAES (AVALIACAOGERAL) QUE NO POSSUEM COMBINAO DEFAULT
   ) LOOP
      SELECT NVL(MIN(NRCOMBQUESTAVAL), 0)
        INTO V_NRCOMBQUESTAVAL
        FROM COMBQUESTAVAL C
       WHERE C.NRORG = A.NRORG
         AND C.NRAVALIACAO = A.NRAVALIACAO;
      IF V_NRCOMBQUESTAVAL <> 0 THEN
         -- SE POSSUI COMBINAO, SETA A PRIMEIRA CRIADA COMO DEFAULT
         UPDATE COMBQUESTAVAL
            SET IDDEFAULT = 'S'
          WHERE NRORG = A.NRORG
            AND NRCOMBQUESTAVAL = V_NRCOMBQUESTAVAL;
      END IF;
   END LOOP;
   -- ##########################################################################
   -- ########################## AVL_LOCALAVALFILIAL ###########################
   -- ##########################################################################
   FOR F IN (
      SELECT *
        FROM FILIAL F
       WHERE F.NRORG = P_NRORG
         AND NOT EXISTS
             (SELECT *
                FROM AVL_LOCALAVALFILIAL L
               WHERE L.NRORG = F.NRORG
                 AND L.CDFILIAL = F.CDFILIAL)
     -- FILIAIS QUE NO POSSUEM LOCAL DE AVALIAO
   ) LOOP
      SELECT NVL(MIN(NRLOCALAVALIACAO), 0)
        INTO V_NRLOCALAVALIACAO
        FROM AVL_LOCALAVALIACAO L
       WHERE L.NRORG = F.NRORG;
      IF V_NRLOCALAVALIACAO <> 0 THEN
         -- PEGA O PRIMEIRO LOCAL DE AVALIAO E ASSOCIA  FILIAL
         NOVO_CODIGO('AVL_LOCALAVALFILIAL', V_NOVOCODIGO, 1, P_NRORG);
         INSERT
           INTO AVL_LOCALAVALFILIAL (
                NRLOCALAVALFILIAL, CDFILIAL, NRLOCALAVALIACAO,
                NRORG, DTINCLUSAO
         )
         VALUES (
                V_NOVOCODIGO, F.CDFILIAL, V_NRLOCALAVALIACAO,
                F.NRORG, SYSDATE
         );
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- #############################################################################
-- #############################################################################
-- #############################################################################
-- ############# IMPLANTAO DA PESQUISA DE OPINIO EM RESTAURANTE #############
-- #############################################################################
-- #############################################################################
-- #############################################################################

BEGIN
   FOR O IN  
     (SELECT NRORG
        FROM ORGANIZACAO) LOOP
      AVL_SETUP (O.NRORG);
   END LOOP;
END;   
/

---- VERSAO --
--BEGIN ATUVEROBJ('AVL_SETUP','0.00.000'); END;
--/
