CREATE OR REPLACE
PROCEDURE ATUALIZA_PARAMPEDIDO_PDR(
P_CDFILIAL FILIAL.CDFILIAL%TYPE
)
AS
   V_UPDATE_TEXT             VARCHAR2(10000);
   V_INSERT_TEXT             VARCHAR2(10000);
   V_CTFILIAL_PAREXP         INTEGER;
   V_CDFILIAL_PADRAO         FILIAL.CDFILIAL%TYPE;
   V_CDGRUPO_OPERADOR        AUTGRUPOP.CDGRUPOPER%TYPE;
   V_CDFILIAL_OPERADOR       AUTGRUPOP.CDFILIAL%TYPE;
   V_NRAUTGRUPOP             AUTGRUPOP.NRAUTGRUPOP%TYPE;
   V_IDCTRLVENEXP_PADRAO     PAREXPEDICAO.IDCTRLVENEXP%TYPE;
BEGIN

   BEGIN
      SELECT CDFILIPADRAO
        INTO V_CDFILIAL_PADRAO
        FROM PARAMGERAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_CDFILIAL_PADRAO := NULL;
   END;


  /*VERIFICA SE EXISTE FILIAL PADRAO PARAMETRIZADA*/
   IF V_CDFILIAL_PADRAO IS NOT NULL THEN
     /*VERIFICA SE EXISTE GRUPO DE OPERADOR PARA ATUALIZAR O PRAMETRO "Grupo com Autorizao para Atualizar Preo de Venda"*/
      BEGIN
         SELECT CDGRUPOPER
           INTO V_CDGRUPO_OPERADOR
           FROM AUTGRUPOP
          WHERE IDAUTGRUPOP = 'ATPR'
            AND CDFILIAL = V_CDFILIAL_PADRAO;
      EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_CDGRUPO_OPERADOR := NULL;
      END;
      /*VERIFICA SE EXISTE COMISSO DO VENDEDOR PARA A FILIAL PADRO*/
      BEGIN
         SELECT IDCTRLVENEXP
           INTO V_IDCTRLVENEXP_PADRAO
           FROM PAREXPEDICAO           
          WHERE CDFILIAL = V_CDFILIAL_PADRAO;
      EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_IDCTRLVENEXP_PADRAO := NULL;
      END;
      /*SELECIONA TODAS AS FILIAIS QUE UTILIZAM A PARAMETRIZAO POR FILIAL PADRAO
        DA TABELA 'PARAMPEDIDO'*/
      FOR C_INSPARAM IN(SELECT CDFILIAL
                          FROM PARAMFILIPADR
                         WHERE IDTABPARAMFILI = 'S'
                           AND NMTABPARAMFILI = 'PARAMPEDIDO'
                           AND CDFILIAL <> V_CDFILIAL_PADRAO
                           AND CDFILIAL = NVL(P_CDFILIAL, CDFILIAL))
      LOOP
         V_UPDATE_TEXT := 'INSERT INTO PARAMPEDIDO (';
         V_INSERT_TEXT := '(SELECT ' ;
         /*SELECIONA OS NOMES DAS COLUNAS DAS TABELA 'PARAMPEDIDO'*/
         FOR C_CAMPO IN (SELECT COLUMN_NAME
                           FROM USER_TAB_COLUMNS
                          WHERE TABLE_NAME   = 'PARAMPEDIDO'
                            AND COLUMN_NAME <> 'CDFILIAL'
                          )
         LOOP
            V_UPDATE_TEXT := V_UPDATE_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
            V_INSERT_TEXT := V_INSERT_TEXT ||C_CAMPO.COLUMN_NAME|| ', ';
         END LOOP;
         /*DELETA OS PARAMETROS DA FILIAL
           QUE UTILIZA PARAMETRIZAO PELA PADRO*/
         DELETE FROM PARAMPEDIDO
          WHERE CDFILIAL = C_INSPARAM.CDFILIAL;
         V_UPDATE_TEXT := V_UPDATE_TEXT||'CDFILIAL) ';
         V_INSERT_TEXT := V_INSERT_TEXT||''''||C_INSPARAM.CDFILIAL||''''||' ';
         V_INSERT_TEXT := V_INSERT_TEXT ||'FROM PARAMPEDIDO ';
         V_INSERT_TEXT := V_INSERT_TEXT ||'WHERE CDFILIAL = '||''''||V_CDFILIAL_PADRAO||''''||') ';
         V_UPDATE_TEXT := V_UPDATE_TEXT || V_INSERT_TEXT;
         EXECUTE IMMEDIATE V_UPDATE_TEXT ;
         
         /*ATUALIZA COMISSAO DO VENDEDOR NAS FILIAIS QUE UTILIZAM PARAMETRIZAO PELA FILIAL PADRAO*/
         IF V_IDCTRLVENEXP_PADRAO IS NOT NULL THEN
            SELECT COUNT(*)
              INTO V_CTFILIAL_PAREXP 
              FROM PAREXPEDICAO
             WHERE CDFILIAL     = C_INSPARAM.CDFILIAL;
            IF V_CTFILIAL_PAREXP > 0 THEN
                UPDATE PAREXPEDICAO
                   SET IDCTRLVENEXP = V_IDCTRLVENEXP_PADRAO                   
                 WHERE CDFILIAL     = C_INSPARAM.CDFILIAL;
            ELSE 
                INSERT INTO PAREXPEDICAO
                (IDCTRLVENEXP, CDFILIAL)
                VALUES
                (V_IDCTRLVENEXP_PADRAO, C_INSPARAM.CDFILIAL);
            END IF;
         END IF;                
      
         IF V_CDGRUPO_OPERADOR IS NOT NULL THEN
            BEGIN
               SELECT CDFILIAL
                 INTO V_CDFILIAL_OPERADOR
                 FROM AUTGRUPOP
                WHERE IDAUTGRUPOP = 'ATPR'
                  AND CDFILIAL = C_INSPARAM.CDFILIAL;
            EXCEPTION
                 WHEN NO_DATA_FOUND THEN
                 V_CDFILIAL_OPERADOR := NULL;
            END;        
         
            IF V_CDFILIAL_OPERADOR IS NOT NULL THEN 
               UPDATE  AUTGRUPOP
                  SET  CDGRUPOPER = V_CDGRUPO_OPERADOR
                WHERE  CDFILIAL   = V_CDFILIAL_OPERADOR
                  AND  IDAUTGRUPOP = 'ATPR';             
             ELSE             
               SELECT MAX(NRAUTGRUPOP) NRAUTGRUPOP
                 INTO V_NRAUTGRUPOP
                 FROM AUTGRUPOP
                WHERE (IDAUTGRUPOP= 'ATPR');
                 
               IF V_NRAUTGRUPOP  IS NOT NULL THEN
                  V_NRAUTGRUPOP := LPAD(TO_CHAR(TO_NUMBER(V_NRAUTGRUPOP)+1), 3, 0);
               ELSE 
                  V_NRAUTGRUPOP := '000';
               END IF;
               INSERT INTO AUTGRUPOP
                  (CDGRUPOPER, CDFILIAL, IDAUTGRUPOP, NRAUTGRUPOP)
               VALUES
                  (V_CDGRUPO_OPERADOR,  C_INSPARAM.CDFILIAL, 'ATPR', V_NRAUTGRUPOP);              
             END IF;
          ELSE
             DELETE FROM AUTGRUPOP
              WHERE (IDAUTGRUPOP = 'ATPR')
                AND (CDFILIAL = C_INSPARAM.CDFILIAL);        
          END IF;
       END LOOP;
       COMMIT;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_PARAMPEDIDO_PDR','5.07.006'); END;
/