var Bco01500_RecontabilizacaoDeTransferencia_Controller = function(templateManager, ValidationEngine, ScreenService, contabilizacaoController, Bco01500_RecontabilizacaoDeTransferencia_Service) {

    var mensagens = {
      vlr: 'Valor inicial deve ser menor do que o valor final.'
    };
    
  /*  this.formatFilter = function(widget, preference) {
        widget.dataSourceFilter = Bco01500_RecontabilizacaoDeTransferencia_Service.buildMainGridDataSourceFilter(widget, preference);
        widget.activate();
    };*/
    
    this.formatFilter = function(widget, preference) {
        var dataInicial = null;
        var dataFinal = null;
        var origem = null;
        var destino = null;
        var filterRow = preference.FILTER_ROW;
        if (filterRow.hasOwnProperty('DATA')){
            if (filterRow.DATA.hasOwnProperty('start')){
                dataInicial = filterRow.DATA.start;
                dataFinal = filterRow.DATA.end;
            }
        }
        if (filterRow.hasOwnProperty('ORIGEM')){
            if (filterRow.ORIGEM.length > 0){
                origem = filterRow.ORIGEM.join('_');
            }
        }
        if (filterRow.hasOwnProperty('DESTINO')){
            if (filterRow.DESTINO.length > 0){
                destino = filterRow.DESTINO.join('_');
            }
        }
        widget.dataSourceFilter.forEach(function(filter){
            switch(filter.name){
                case 'CDEMPRESA': filter.value = filterRow.CDEMPRESA;
                  break;
                case 'ORIGEM': filter.value = (origem) ? origem : null;
                  break;
                case 'DESTINO': filter.value = (destino) ? destino : null; 
                  break;
                case 'DATAINI': filter.value = (dataInicial) ? dataInicial : null;
                  break;
                case 'DATAFIN': filter.value = (dataFinal) ? dataFinal : null;
                  break;
                case 'VRINI': filter.value = (filterRow.VRINI) ? filterRow.VRINI : null;
                  break;
                case 'VRFIN': filter.value = (filterRow.VRFIN) ? filterRow.VRFIN : null;
                  break;
                case 'DSHISTTBANC': filter.value = (filterRow.DSHISTTBANC) ? filterRow.DSHISTTBANC : null;
                  break;
            }  
        });      
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('DATA')){
            delete preference.CUSTOM_FILTER_ROW.DATA;
        }
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('ORIGEM'))
            if (preference.CUSTOM_FILTER_ROW.ORIGEM.length > 0)
                preference.CUSTOM_FILTER_ROW.ORIGEM = preference.CUSTOM_FILTER_ROW.ORIGEM.join('_');
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('DESTINO'))
            if (preference.CUSTOM_FILTER_ROW.DESTINO.length > 0)
                preference.CUSTOM_FILTER_ROW.DESTINO = preference.CUSTOM_FILTER_ROW.DESTINO.join('_');
        widget.activate();
    };
    
    this.loadGridTransferencias = function(widget) {
      widget.widgets[0].dataSourceFilter = [
        {
          name: "NRTRANBANC",
          operator: "=",
          value: widget.currentRow.NRTRANBANC
        },
        {
          name: "CDEMPRESA",
          operator: "=",
          value: widget.currentRow.CDEMPRESA
        }
      ];
      
      widget.widgets[0].reload();
      
    };
    
    this.onChangeValue = function(field, widget) {
        if(widget.currentRow.VRINI && widget.currentRow.VRFIN) {
          if(widget.currentRow.VRINI >= widget.currentRow.VRFIN) {
            if(field === 'VRINI') widget.currentRow.VRINI = undefined;
            else widget.currentRow.VRFIN = undefined;
            ScreenService.showMessage(mensagens.vlr);
          }
        }
        if(widget.currentRow.VRINI || widget.currentRow.VRFIN) {
          widget.getField('VRINI').validations = {required: true};
          widget.getField('VRFIN').validations = {required: true};
        }
        else {
          widget.getField('VRINI').validations = {};
          widget.getField('VRFIN').validations = {};
        }
    };
    
    this.consultaContabilizacao = function(widget){

        var checkedRows = widget.getCheckedRows();
        var contabil = [];

        checkedRows.forEach(function(checkedRow) {
            contabil.push({
            	CDEMPRESA : checkedRow.CDEMPRESA,	
	        	NRLANCCONT: checkedRow.NRLCTBTRAN
            });
        });
        
        if(contabil.length > 0)
            contabilizacaoController.exibeContabilizacao(contabil);
        else 
        	ScreenService.showMessage('Título(s) marcado(s) não possui(em) contabilização(ões).');
    };
    
    this.recontabilizarTransferencias = function(widget) {    
        var checkedRows = widget.dataSource.checkedRows;
        
        Bco01500_RecontabilizacaoDeTransferencia_Service.recontabilizarTransferencias(checkedRows).then(function(success){
          ScreenService.showMessage("Recontabilizacao feita com sucesso.");   
        }).catch(function(error) {
          
          if (contabilizacaoController.checkErrosContabilizacao(error, "Não foi possível realizar todos os lançamentos devido a erros na contablização.")) {
            var message = "Timeout";
            if (error.data.error) {
              message = error.data.error;
            }  
            ScreenService.showMessage(message);
          }
          
        });
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Bco01500_RecontabilizacaoDeTransferencia_Controller', Bco01500_RecontabilizacaoDeTransferencia_Controller);
});